diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingCherry.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
similarity index 71%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSaplingCherry.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
index 2da2ab4a8..9fd501014 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingCherry.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
@@ -7,25 +7,25 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeCherry;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 
-public class BlockSaplingCherry extends BlockSaplingBase
+public class BlockLogicSaplingCherry extends BlockLogicSaplingBase
 {
 
-	public BlockSaplingCherry(String key, String namespaceId, int id)
+	public BlockLogicSaplingCherry(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
     }
 
     @Override
 	public void growTree(World world, int x, int y, int z, Random random)
     {
-        WorldFeature treeBig  = new WorldFeatureTreeFancy(Blocks.LEAVES_CHERRY.id, Blocks.LOG_CHERRY.id);
-        WorldFeature treeSmall = new WorldFeatureTreeCherry(Blocks.LEAVES_CHERRY.id, Blocks.LOG_CHERRY.id, 4);
+        WorldFeature treeBig  = new WorldFeatureTreeFancy(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id());
+        WorldFeature treeSmall = new WorldFeatureTreeCherry(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id(), 4);
         world.setBlock(x, y, z, 0);
 
         if(!treeSmall.place(world, random, x, y, z))
         {
             if(!treeBig.place(world, random, x, y, z)) {
-                world.setBlock(x, y, z, id);
+                world.setBlock(x, y, z, id());
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingEucalyptus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingEucalyptus.java
similarity index 68%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSaplingEucalyptus.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingEucalyptus.java
index db7174b2b..74c99042b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingEucalyptus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingEucalyptus.java
@@ -6,12 +6,12 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
 
-public class BlockSaplingEucalyptus extends BlockSaplingBase
+public class BlockLogicSaplingEucalyptus extends BlockLogicSaplingBase
 {
 
-	public BlockSaplingEucalyptus(String key, String namespaceId, int id)
+	public BlockLogicSaplingEucalyptus(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
     }
     
     @Override
@@ -20,11 +20,11 @@ public class BlockSaplingEucalyptus extends BlockSaplingBase
 
         world.setBlock(x, y, z, 0);
 
-        WorldFeature tree = new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id, Blocks.LOG_EUCALYPTUS.id);
+        WorldFeature tree = new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id(), Blocks.LOG_EUCALYPTUS.id());
         tree.init(1.0D, 1.0D, 1.0D);
         if(!tree.place(world, random, x, y, z))
         {
-            world.setBlock(x, y, z, id);
+            world.setBlock(x, y, z, id());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingOak.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingOak.java
similarity index 73%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingOak.java
index 3e4cacce2..e1176335f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingOak.java
@@ -7,25 +7,25 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
 
-public class BlockSaplingOak extends BlockSaplingBase
+public class BlockLogicSaplingOak extends BlockLogicSaplingBase
 {
 
-	public BlockSaplingOak(String key, String namespaceId, int id)
+	public BlockLogicSaplingOak(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
     }
     
     @Override
 	public void growTree(World world, int x, int y, int z, Random random)
     {
-    	WorldFeature treeBig = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id);
-        WorldFeature treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id, 4);
+    	WorldFeature treeBig = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id());
+        WorldFeature treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
     	world.setBlock(x, y, z, 0);
 
         if(!treeSmall.place(world, random, x, y, z))
         {
             if(!treeBig.place(world, random, x, y, z)) {
-                world.setBlock(x, y, z, id);
+                world.setBlock(x, y, z, id());
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingPalm.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPalm.java
similarity index 76%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSaplingPalm.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPalm.java
index 2ad4876a4..1d7214e41 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingPalm.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPalm.java
@@ -5,17 +5,17 @@ import java.util.Random;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreePalm;
 
-public class BlockSaplingPalm extends BlockSaplingBase {
+public class BlockLogicSaplingPalm extends BlockLogicSaplingBase {
 
-	public BlockSaplingPalm(String key, String namespaceId, int id) {
-		super(key, namespaceId, id);
+	public BlockLogicSaplingPalm(Block<?> block) {
+		super(block);
 		
 		this.canGrowOnSand = true;
 	}
 	
 	@Override
 	public void growTree(World world, int x, int y, int z, Random random) {
-    	boolean big = world.getBlockId(x, y - 1, z) != Blocks.SAND.id;
+    	boolean big = world.getBlockId(x, y - 1, z) != Blocks.SAND.id();
     	
     	new WorldFeatureTreePalm(Blocks.LOG_PALM, Blocks.LEAVES_PALM, big, true, false).place(world, random, x, y, z);
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingPine.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
similarity index 67%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSaplingPine.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
index f783e9865..0ec3595da 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingPine.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
@@ -7,12 +7,12 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
 
-public class BlockSaplingPine extends BlockSaplingBase
+public class BlockLogicSaplingPine extends BlockLogicSaplingBase
 {
 
-	public BlockSaplingPine(String key, String namespaceId, int id)
+	public BlockLogicSaplingPine(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
     }
 
     @Override
@@ -40,15 +40,15 @@ public class BlockSaplingPine extends BlockSaplingBase
     @Override
 	public void growTree(World world, int x, int y, int z, Random random)
     {
-        Object treeBig  = new WorldFeatureTreeTaigaTall(Blocks.LEAVES_PINE.id, Blocks.LOG_PINE.id);
-        Object treeSmall = new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id, Blocks.LOG_PINE.id);
+        WorldFeature treeBig  = new WorldFeatureTreeTaigaTall(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
+        WorldFeature treeSmall = new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
         
     	world.setBlock(x, y, z, 0);
 
-        if(!((WorldFeature) (treeSmall)).place(world, random, x, y, z))
+        if(!treeSmall.place(world, random, x, y, z))
         {
-            if(!((WorldFeature) (treeBig)).place(world, random, x, y, z)) {
-                world.setBlock(x, y, z, id);
+            if(!treeBig.place(world, random, x, y, z)) {
+                world.setBlock(x, y, z, id());
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingRetro.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingRetro.java
similarity index 72%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSaplingRetro.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingRetro.java
index 24e2c885b..37b2fc574 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingRetro.java
@@ -7,26 +7,26 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
 
-public class BlockSaplingRetro extends BlockSaplingBase
+public class BlockLogicSaplingRetro extends BlockLogicSaplingBase
 {
 
-	public BlockSaplingRetro(String key, String namespaceId, int id)
+	public BlockLogicSaplingRetro(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
     }
 
 
     @Override
 	public void growTree(World world, int x, int y, int z, Random random)
     {
-        WorldFeature treeBig  = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK_RETRO.id, Blocks.LOG_OAK.id);
-        WorldFeature treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK_RETRO.id, Blocks.LOG_OAK.id, 4);
+        WorldFeature treeBig  = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK_RETRO.id(), Blocks.LOG_OAK.id());
+        WorldFeature treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK_RETRO.id(), Blocks.LOG_OAK.id(), 4);
         world.setBlock(x, y, z, 0);
 
         if(!treeSmall.place(world, random, x, y, z))
         {
             if(!treeBig.place(world, random, x, y, z)) {
-                world.setBlock(x, y, z, id);
+                world.setBlock(x, y, z, id());
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingShrub.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingShrub.java
similarity index 69%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSaplingShrub.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingShrub.java
index 4a329f5e7..488b42591 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingShrub.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingShrub.java
@@ -6,12 +6,12 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
 
-public class BlockSaplingShrub extends BlockSaplingBase
+public class BlockLogicSaplingShrub extends BlockLogicSaplingBase
 {
 
-	public BlockSaplingShrub(String key, String namespaceId, int id)
+	public BlockLogicSaplingShrub(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
     }
     
     @Override
@@ -20,11 +20,11 @@ public class BlockSaplingShrub extends BlockSaplingBase
 
         world.setBlock(x, y, z, 0);
 
-        WorldFeature tree = new WorldFeatureTreeShrub(Blocks.LEAVES_SHRUB.id, Blocks.LOG_OAK.id);
+        WorldFeature tree = new WorldFeatureTreeShrub(Blocks.LEAVES_SHRUB.id(), Blocks.LOG_OAK.id());
         
         if(!tree.place(world, random, x, y, z))
         {
-            world.setBlock(x, y, z, id);
+            world.setBlock(x, y, z, id());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingThorn.java
similarity index 67%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingThorn.java
index 59ba350e7..9a5a74d83 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingThorn.java
@@ -6,12 +6,12 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
 
-public class BlockSaplingThorn extends BlockSaplingBase
+public class BlockLogicSaplingThorn extends BlockLogicSaplingBase
 {
 
-    public BlockSaplingThorn(String key, String namespaceId, int id)
+    public BlockLogicSaplingThorn(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
     }
 
 
@@ -20,11 +20,11 @@ public class BlockSaplingThorn extends BlockSaplingBase
     {
 
         world.setBlock(x, y, z, 0);
-        WorldFeature treeFeature = new WorldFeatureTreeThorn(1, Blocks.LOG_THORN.id, 0, Blocks.LEAVES_THORN.id, 0);
+        WorldFeature treeFeature = new WorldFeatureTreeThorn(1, Blocks.LOG_THORN.id(), 0, Blocks.LEAVES_THORN.id(), 0);
 
         if(!treeFeature.place(world, random, x, y, z))
         {
-            world.setBlock(x, y, z, id);
+            world.setBlock(x, y, z, id());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSeat.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
similarity index 86%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSeat.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
index 268be8395..7a46e4ab6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSeat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
@@ -10,13 +10,12 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class BlockSeat
-    extends BlockTileEntity
+public class BlockLogicSeat extends BlockLogic
 {
-    public BlockSeat(String key, String namespaceId, int id) {
-        super(key, namespaceId, id, Material.wood);
-        
+    public BlockLogicSeat(Block<?> block) {
+        super(block, Material.wood);
         setBlockBounds(0f, 0f, 0f, 1f, 9f / 16f, 1f);
+        block.withEntity(() -> new TileEntitySeat(block));
     }
 
     @Override
@@ -54,11 +53,6 @@ public class BlockSeat
     public boolean isSolidRender() {
         return false;
     }
-    
-    @Override
-    protected TileEntity getNewBlockEntity() {
-        return new TileEntitySeat(this);
-    }
 
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
similarity index 94%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSign.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
index 02db3af0a..11124b42c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
@@ -13,17 +13,18 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockSign extends BlockTileEntity
+public class BlockLogicSign extends BlockLogic
 {
     private final boolean isFreeStanding;
 
-	public BlockSign(String key, String namespaceId, int id, boolean isFreeStanding)
+	public BlockLogicSign(Block<?> block, boolean isFreeStanding)
     {
-        super(key, namespaceId, id, Material.wood);
+        super(block, Material.wood);
         this.isFreeStanding = isFreeStanding;
         float f = 0.25F;
         float f1 = 1.0F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f1, 0.5F + f);
+        block.withEntity(TileEntitySign::new);
     }
 
     @Override
@@ -94,12 +95,6 @@ public class BlockSign extends BlockTileEntity
         return false;
     }
 
-    @Override
-	protected TileEntity getNewBlockEntity()
-    {
-        return new TileEntitySign();
-    }
-
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSlab.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
similarity index 85%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSlab.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
index 84bfed3e5..e5ba5926a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
@@ -18,24 +19,31 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockSlab extends Block
+public class BlockLogicSlab extends BlockLogic
 {
+    public Block<?> modelBlock;
+    public int modelBlockMetadata;
 
-    public BlockSlab(Block modelBlock, String namespaceId, int id)
+    public BlockLogicSlab(Block<?> block, Block<?> modelBlock)
     {
-        this(modelBlock, namespaceId, id, 0);
-        setBlockItem(() -> new ItemBlockSlab(this));
+        this(modelBlock, modelBlock, 0);
+        block.setBlockItem(() -> new ItemBlockSlab<>(block));
     }
-    
-    public BlockSlab(Block modelBlock, String namespaceId, int id, int modelBlockMetadata)
+
+    public BlockLogicSlab(Block<?> block, Block<?> modelBlock, int modelBlockMetadata)
     {
-    	super("slab." + modelBlock.key.substring(5), namespaceId, id, modelBlock.blockMaterial);
+    	super(block, Material.stone);
         this.modelBlock = modelBlock;
         this.modelBlockMetadata = modelBlockMetadata;
-        withHardness(modelBlock.blockHardness);
-        withBlastResistance(modelBlock.blastResistance / 3F);
-        withLightEmission(Blocks.lightEmission[modelBlock.id]);
-        withLightBlock(1);
+        block.withHardness(modelBlock.blockHardness);
+        block.withBlastResistance(modelBlock.blastResistance / 3F);
+        block.withLightEmission(modelBlock.emission);
+        block.withLightBlock(1);
+    }
+
+    @Override
+    public @NotNull Material getMaterial() {
+        return modelBlock.getMaterial();
     }
 
     @Override
@@ -83,10 +91,10 @@ public class BlockSlab extends Block
         {
             for (ItemStack stack : result)
             {
-                if (stack.itemID == modelBlock.id)
+                if (stack.itemID == modelBlock.id())
                 {
                     stack.setMetadata(meta & 0xF0);
-                    stack.itemID = this.id;
+                    stack.itemID = this.id();
                     if ((meta & 0x3) == 1 && dropCause != EnumDropCause.PICK_BLOCK) stack.stackSize = 2;
                     else stack.stackSize = 1;
                 }
@@ -105,10 +113,10 @@ public class BlockSlab extends Block
         {
             for (ItemStack stack : result)
             {
-                if (stack.itemID == modelBlock.id)
+                if (stack.itemID == modelBlock.id())
                 {
                     stack.setMetadata(meta & 0xF0);
-                    stack.itemID = this.id;
+                    stack.itemID = this.id();
                     if ((meta & 0x3) == 1 && dropCause != EnumDropCause.PICK_BLOCK) stack.stackSize = 2;
                     else stack.stackSize = 1;
                 }
@@ -123,12 +131,12 @@ public class BlockSlab extends Block
     {
         return modelBlock.tickDelay();
     }
-
     @Override
     public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity)
     {
         modelBlock.handleEntityInside(world, x, y, z, entity, entityVelocity);
     }
+
     @Override
     public boolean isCollidable()
     {
@@ -144,11 +152,10 @@ public class BlockSlab extends Block
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        return world.getBlockId(x, y -1, z) == id ||
-                world.getBlockId(x, y +1, z) == id ||
+        return world.getBlockId(x, y -1, z) == id() ||
+                world.getBlockId(x, y +1, z) == id() ||
                 super.canPlaceBlockAt(world, x, y, z);
     }
-
     @Override
     public void onEntityWalking(World world, int x, int y, int z, Entity entity)
     {
@@ -164,6 +171,7 @@ public class BlockSlab extends Block
     {
         return modelBlock.onBlockRightClicked(world, x, y, z, player, side, xPlaced, yPlaced);
     }
+
     @Override
     public void onBlockDestroyedByExplosion(World world, int x, int y, int z)
     {
@@ -189,7 +197,7 @@ public class BlockSlab extends Block
             world.setBlockMetadataWithNotify(x, y, z, 0);
         }
     }
-    
+
     @Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
@@ -208,24 +216,21 @@ public class BlockSlab extends Block
     {
         return modelBlock.getBlockBrightness(blockAccess, x, y, z);
     }
-    
+
     @Override
     public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
         modelBlock.onBlockLeftClicked(world, x, y, z, player, side, xHit, yHit);
     }
-
     @Override
 	public void animationTick(World world, int x, int y, int z, Random rand)
     {
         modelBlock.animationTick(world, x, y, z, rand);
     }
+
     @Override
-    public MaterialColor getMaterialColor(){
+    public @NotNull MaterialColor getMaterialColor(){
         return modelBlock.getMaterialColor();
     }
 
-    public Block modelBlock;
-    public int modelBlockMetadata;
-
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSlabPaintable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPaintable.java
similarity index 54%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSlabPaintable.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPaintable.java
index 2952fb178..f06aa7f0e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSlabPaintable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPaintable.java
@@ -3,15 +3,15 @@ package net.minecraft.core.block;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 
-public class BlockSlabPaintable extends BlockSlab implements IPaintable {
-    public BlockSlabPaintable(Block modelBlock, String namespaceId, int id) {
-        super(modelBlock, namespaceId, id);
+public class BlockLogicSlabPaintable extends BlockLogicSlab implements IPaintable {
+    public BlockLogicSlabPaintable(Block<?> block, Block<?> modelBlock) {
+        super(block, modelBlock);
     }
 
     @Override
     public void setColor(World world, int x, int y, int z, DyeColor color) {
         final int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockAndMetadata(x, y, z, Blocks.SLAB_PLANKS_PAINTED.id, meta);
-        ((IPaintable) Blocks.SLAB_PLANKS_PAINTED).setColor(world, x, y, z, color);
+        world.setBlockAndMetadata(x, y, z, Blocks.SLAB_PLANKS_PAINTED.id(), meta);
+        Blocks.SLAB_PLANKS_PAINTED.getLogic().setColor(world, x, y, z, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSlabPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPainted.java
similarity index 90%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSlabPainted.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPainted.java
index 1e00cbd03..438524d4c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSlabPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPainted.java
@@ -10,11 +10,11 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockSlabPainted extends BlockSlab implements IPainted
+public class BlockLogicSlabPainted extends BlockLogicSlab implements IPainted
 {
-	public BlockSlabPainted(Block modelBlock, String namespaceId, int id)
+	public BlockLogicSlabPainted(Block<?> block, Block<?> modelBlock)
 	{
-		super(modelBlock, namespaceId, id);
+		super(block, modelBlock);
 	}
 	
 	@Override
@@ -52,7 +52,7 @@ public class BlockSlabPainted extends BlockSlab implements IPainted
 	@Override
 	public void removeDye(World world, int x, int y, int z) {
 		final int meta = world.getBlockMetadata(x, y, z);
-		world.setBlockAndMetadataWithNotify(x, y, z, Blocks.PLANKS_OAK.id, meta & 0xF);
+		world.setBlockAndMetadataWithNotify(x, y, z, Blocks.PLANKS_OAK.id(), meta & 0xF);
 	}
 
 	@Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlippery.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlippery.java
new file mode 100644
index 000000000..7a8aa2e09
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlippery.java
@@ -0,0 +1,11 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+
+public class BlockLogicSlippery extends BlockLogic {
+
+    public BlockLogicSlippery(Block<?> block, Material material) {
+        super(block, material);
+        block.friction = 0.98F;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
similarity index 87%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSnow.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
index 1edae8d5c..2f2b636bb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
@@ -10,13 +10,13 @@ import net.minecraft.core.block.material.Material;
 
 import java.util.Random;
 
-public class BlockSnow extends Block
+public class BlockLogicSnow extends BlockLogic
 {
 
-	public BlockSnow(String key, String namespaceId, int id)
+	public BlockLogicSnow(Block<?> block)
     {
-        super(key, namespaceId, id, Material.snow);
-        setTicking(true);
+        super(block, Material.snow);
+        block.setTicking(true);
     }
 
     public int quantityDropped(int meta, Random rand)
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSoulSand.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSoulSand.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
index 3086d2d15..b326e2e02 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSoulSand.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
@@ -6,12 +6,12 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockSoulSand extends Block
+public class BlockLogicSoulSand extends BlockLogic
 {
 
-    public BlockSoulSand(String key, String namespaceId, int id)
+    public BlockLogicSoulSand(Block<?> block)
     {
-        super(key, namespaceId, id, Material.soulsand);
+        super(block, Material.soulsand);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSpikes.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
similarity index 91%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSpikes.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
index 51c8ca404..d3ba8da2a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSpikes.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
@@ -16,13 +16,13 @@ import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 
-public class BlockSpikes extends Block
+public class BlockLogicSpikes extends BlockLogic
 {
     public static final int MASK_POWERED = 0b0000_0001;
 
-    public BlockSpikes(String key, String namespaceId, int id, Material mat)
+    public BlockLogicSpikes(Block<?> block, Material mat)
     {
-        super(key, namespaceId, id, mat);
+        super(block, mat);
     }
 
     @Override
@@ -46,7 +46,7 @@ public class BlockSpikes extends Block
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        return world.canPlaceOnSurfaceOfBlock(x, y -1, z) || world.getBlockId(x, y - 1, z) == Blocks.MOBSPAWNER.id;
+        return world.canPlaceOnSurfaceOfBlock(x, y -1, z) || world.getBlockId(x, y - 1, z) == Blocks.MOBSPAWNER.id();
     }
 
 	@Override
@@ -55,7 +55,7 @@ public class BlockSpikes extends Block
 			return;
 		}
 		
-		boolean destroy = !world.canPlaceOnSurfaceOfBlock(x, y - 1, z) && world.getBlockId(x, y - 1, z) != Blocks.MESH.id && world.getBlockId(x, y - 1, z) != Blocks.MOBSPAWNER.id;
+		boolean destroy = !world.canPlaceOnSurfaceOfBlock(x, y - 1, z) && world.getBlockId(x, y - 1, z) != Blocks.MESH.id() && world.getBlockId(x, y - 1, z) != Blocks.MOBSPAWNER.id();
 		if(destroy) {
 			dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
 			world.setBlockWithNotify(x, y, z, 0);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSpinifex.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpinifex.java
similarity index 82%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSpinifex.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSpinifex.java
index d8d413723..18fb54366 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSpinifex.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpinifex.java
@@ -5,12 +5,12 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class BlockSpinifex extends BlockFlower
+public class BlockLogicSpinifex extends BlockLogicFlower
 {
 
-	public BlockSpinifex(String key, String namespaceId, int id)
+	public BlockLogicSpinifex(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
         float f = 0.4F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.8F, 0.5F + f);
     }
